using Infrastructure.HttpUserContext;

namespace Infrastructure.Extensions;

public static class UserContextSetup
{
    /// <summary>
    /// 配置用户上下文服务 T为主键类型
    /// </summary>
    /// <param name="services"></param>
    /// <typeparam name="T"></typeparam>
    /// <returns></returns>
    public static IServiceCollection AddDefaultUserContext<T>(this IServiceCollection services) where T : IEquatable<T>
    {
        ArgumentNullException.ThrowIfNull(services);
        services.AddHttpContextAccessor();
        services.TryAddScoped(typeof(IUserContext<T>), typeof(UserContext<T>));
        return services;
    }
}